Skip to content

# Download

The tool to check the availability or syntax of domain, IP or URL.

::

    ██████╗ ██╗   ██╗███████╗██╗   ██╗███╗   ██╗ ██████╗███████╗██████╗ ██╗     ███████╗
    ██╔══██╗╚██╗ ██╔╝██╔════╝██║   ██║████╗  ██║██╔════╝██╔════╝██╔══██╗██║     ██╔════╝
    ██████╔╝ ╚████╔╝ █████╗  ██║   ██║██╔██╗ ██║██║     █████╗  ██████╔╝██║     █████╗
    ██╔═══╝   ╚██╔╝  ██╔══╝  ██║   ██║██║╚██╗██║██║     ██╔══╝  ██╔══██╗██║     ██╔══╝
    ██║        ██║   ██║     ╚██████╔╝██║ ╚████║╚██████╗███████╗██████╔╝███████╗███████╗
    ╚═╝        ╚═╝   ╚═╝      ╚═════╝ ╚═╝  ╚═══╝ ╚═════╝╚══════╝╚═════╝ ╚══════╝╚══════╝

Provides the download helpers.

Author: Nissar Chababy, @funilrys, contactTATAfunilrysTODTODcom

Special thanks: https://pyfunceble.github.io/#/special-thanks

Contributors: https://pyfunceble.github.io/#/contributors

Project link: https://github.com/funilrys/PyFunceble

Project documentation: https://docs.pyfunceble.com

Project homepage: https://pyfunceble.github.io/

License: ::

    Copyright 2017, 2018, 2019, 2020, 2022, 2023, 2024, 2025 Nissar Chababy

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        https://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

## `DownloadHelper`

Simplification of the downloads.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`url` | `str` |  | `None`
`retries` | `int` | The number of time we have to retry before raising an exception. | `3`
`certificate_validation` | `bool` | The state of the certificate validation. | `True`
`own_proxy_handler` | `bool` | Whether we should use our own proxy handler or not. | `True`
`proxies` | `dict` | The proxy to use. When :code:`own_proxy_handler` is set to :code:`True`, the proxies are expected to come from the global configuration. Otherwise, the proxies are expected to be a dictionary as defined by the requests library. | `None`

Source code in `PyFunceble/helpers/download.py`

     63
     64
     65
     66
     67
     68
     69
     70
     71
     72
     73
     74
     75
     76
     77
     78
     79
     80
     81
     82
     83
     84
     85
     86
     87
     88
     89
     90
     91
     92
     93
     94
     95
     96
     97
     98
     99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    257
    258
    259
    260
    261
    262
    263
    264
    265
    266
    267
    268
    269
    270
    271
    272
    273
    274
    275
    276
    277
    278
    279
    280
    281
    282
    283
    284
    285
    286
    287
    288
    289
    290
    291
    292
    293
    294
    295
    296
    297
    298
    299
    300
    301
    302
    303
    304
    305
    306
    307
    308
    309
    310
    311
    312
    313
    314
    315
    316
    317
    318
    319
    320
    321
    322
    323
    324
    325
    326
    327
    328
    329
    330
    331
    332
    333
    334
    335
    336
    337
    338
    339
    340
    341
    342
    343
    344
    345
    346
    347
    348
    349
    350
    351
    352
    353
    354
    355
    356
    357
    358
    359
    360
    361
    362
    363
    364
    365
    366
    367
    368
    369
    370
    371
    372
    373
    374
    375
    376
    377
    378
    379
    380
    381
    382
    383

    class DownloadHelper:
        """
        Simplification of the downloads.

        :param str url:
        :param int retries:
            The number of time we have to retry before raising an exception.
        :param bool certificate_validation:
            The state of the certificate validation.
        :param bool own_proxy_handler:
            Whether we should use our own proxy handler or not.
        :param dict proxies:
            The proxy to use.

            When :code:`own_proxy_handler` is set to :code:`True`, the proxies
            are expected to come from the global configuration.
            Otherwise, the proxies are expected to be a dictionary as defined
            by the requests library.
        """

        _url: Optional[str] = None
        _certificate_validation: bool = True
        _retries: int = 3
        _proxies: Optional[dict] = None

        _session = None
        _own_proxy_handler: Optional[bool] = True
        _proxies: Optional[dict] = None

        def __init__(
            self,
            url: Optional[str] = None,
            *,
            certificate_validation: bool = True,
            retries: int = 3,
            own_proxy_handler: Optional[bool] = True,
            proxies: Optional[dict] = None,
        ) -> None:
            if url is not None:
                self.url = url

            if proxies is not None:
                self.proxies = proxies

            self.retries = retries
            self.certificate_validation = bool(certificate_validation)
            self.own_proxy_handler = own_proxy_handler

        @property
        def session(self) -> requests.Session:
            """
            Provides the current state of the :code:`_session` attribute.
            """

            if not self._session:
                if self.own_proxy_handler:
                    # pylint: disable=import-outside-toplevel
                    from PyFunceble.query.requests.requester import Requester

                    self._session = Requester(proxy_pattern=self.proxies)
                else:
                    self._session = requests.Session()
                    self._session.proxies = self.proxies

                    retries = Retry(total=self.retries)
                    adapter = HTTPAdapter(max_retries=retries)

                    self._session.mount("http://", adapter)
                    self._session.mount("https://", adapter)

            return self._session

        @property
        def url(self) -> Optional[str]:
            """
            Provides the current state of the :code:`_url` attribute.
            """

            return self._url

        @url.setter
        def url(self, value: str) -> None:
            """
            Sets the url to work with.

            :param value:
                The URL to set.

            :raise TypeError:
                When :code:`value` is not a :py:class:`str`.
            """

            if not isinstance(value, str):
                raise TypeError(f"<value> should be {str}, {type(value)} given.")

            self._url = value

        def set_url(self, value: str) -> "DownloadHelper":
            """
            Sets the url to work with.

            :param value:
                The URL to set.
            """

            self.url = value

            return self

        @property
        def certificate_validation(self) -> bool:
            """
            Provides the current state of the :code:`certificate_validation`
            attribute.
            """

            return self._certificate_validation

        @certificate_validation.setter
        def certificate_validation(self, value: bool) -> None:
            """
            Sets the value of the certificate validation.

            :param value:
                The value to set.

            :raise TypeError:
                When :code:`value` is not a :py:class:`bool`
            """

            if not isinstance(value, bool):
                raise TypeError(f"<value> should be {bool}, {type(value)} given.")

            self._certificate_validation = value

        def set_certificate_validation(self, value: bool) -> "DownloadHelper":
            """
            Sets the value of the certificate validation.

            :param value:
                The value to set.
            """

            self.certificate_validation = value

            return self

        @property
        def retries(self) -> int:
            """
            Provides the current state of the :code:`_retries` attributes.
            """

            return self._retries

        @retries.setter
        def retries(self, value: int) -> None:
            """
            Sets the number of retries we are allowed to perform before raising an
            exception.

            :param value:
                The number of retry to apply.i

            :raise TypeError:
                When :code:`value` is not a :py:class:`int`.
            :raise ValueError:
                When :code:`value` is lower than :code:`0`.
            """

            if not isinstance(value, int):
                raise TypeError(f"<value> should be {int}, {type(value)} given.")

            if value <= 0:
                raise ValueError("<value> should greater than zero.")

            self._retries = value

        def set_retries(self, value: int) -> "DownloadHelper":
            """
            Sets the number of retries we are allowed to perform before raising an
            exception.

            :param value:
                The number of retry to apply.i
            """

            self.retries = value

            return self

        @property
        def own_proxy_handler(self) -> Optional[bool]:
            """
            Provides the current state of the :code:`own_proxy_handler` attribute.
            """

            return self._own_proxy_handler

        @own_proxy_handler.setter
        def own_proxy_handler(self, value: bool) -> None:
            """
            Sets the state of the own proxy handler.

            :param value:
                The value to set.

            :raise TypeError:
                When :code:`value` is not a :py:class:`bool`.
            """

            if not isinstance(value, bool):
                raise TypeError(f"<value> should be {bool}, {type(value)} given.")

            self._own_proxy_handler = value

            if value:
                # We force the recreation of the session.
                self._session = None

        def set_own_proxy_handler(self, value: bool) -> "DownloadHelper":
            """
            Sets the state of the own proxy handler.

            :param value:
                The value to set.
            """

            self.own_proxy_handler = value

            return self

        @property
        def proxies(self) -> Optional[dict]:
            """
            Provides the current state of the :code:`_proxies` attribute.
            """

            return self._proxies

        @proxies.setter
        def proxies(self, value: Optional[dict]) -> None:
            """
            Sets the proxy to use.

            :param value:
                The proxy to use.

                When :code:`own_proxy_handler` is set to :code:`True`, the proxies
                are expected to come from the global configuration.
                Otherwise, the proxies are expected to be a dictionary as defined
                by the requests library.

            :raise TypeError:
                When :code:`value` is not a :py:class:`dict`.
            """

            if not isinstance(value, dict):
                raise TypeError(f"<value> should be {dict}, {type(value)} given.")

            self._proxies = value

            if value:
                # We force the recreation of the session.
                self._session = None

        def set_proxies(self, value: Optional[dict]) -> "DownloadHelper":
            """
            Sets the proxy to use.

            :param value:
                The proxy to use.

                When :code:`own_proxy_handler` is set to :code:`True`, the proxies
                are expected to come from the global configuration.
                Otherwise, the proxies are expected to be a dictionary as defined
                by the requests library.
            """

            self.proxies = value

            return self

        def download_text(
            self,
            *,
            destination: Optional[str] = None,
        ) -> str:
            """
            Download the body of the set url.

            .. note::
                if :code:`destination` is set to :code:`None`,
                we only return the output.

                Otherwise, we save the output into the given
                destination, but we also return the output.

            :param destination: The download destination.

            :raise UnableToDownload: When could not unable to download the URL.
            """

            try:
                req = self.session.get(self.url, verify=self.certificate_validation)

                if req.status_code == 200:
                    response = req.text

                    if destination and isinstance(destination, str):
                        FileHelper(destination).write(req.text, overwrite=True)

                    return response

                raise PyFunceble.helpers.exceptions.UnableToDownload(
                    f"{req.url} (retries: {self.retries} | status code: {req.status_code})"
                )
            except requests.exceptions.RequestException as exception:
                raise PyFunceble.helpers.exceptions.UnableToDownload(
                    f"{self.url} (could not resolve?)"
                ) from exception

### `certificate_validation` `property` `writable`

Provides the current state of the :code:`certificate_validation` attribute.

### `own_proxy_handler` `property` `writable`

Provides the current state of the :code:`own_proxy_handler` attribute.

### `proxies` `property` `writable`

Provides the current state of the :code:`_proxies` attribute.

### `retries` `property` `writable`

Provides the current state of the :code:`_retries` attributes.

### `session` `property`

Provides the current state of the :code:`_session` attribute.

### `url` `property` `writable`

Provides the current state of the :code:`_url` attribute.

### `download_text(*, destination=None)`

Download the body of the set url.

.. note:: if :code:`destination` is set to :code:`None`, we only return the output.

    Otherwise, we save the output into the given
    destination, but we also return the output.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`destination` | `Optional[str]` | The download destination. | `None`

Raises:

Type | Description
--- | ---
`UnableToDownload` | When could not unable to download the URL.

Source code in `PyFunceble/helpers/download.py`

    346
    347
    348
    349
    350
    351
    352
    353
    354
    355
    356
    357
    358
    359
    360
    361
    362
    363
    364
    365
    366
    367
    368
    369
    370
    371
    372
    373
    374
    375
    376
    377
    378
    379
    380
    381
    382
    383

    def download_text(
        self,
        *,
        destination: Optional[str] = None,
    ) -> str:
        """
        Download the body of the set url.

        .. note::
            if :code:`destination` is set to :code:`None`,
            we only return the output.

            Otherwise, we save the output into the given
            destination, but we also return the output.

        :param destination: The download destination.

        :raise UnableToDownload: When could not unable to download the URL.
        """

        try:
            req = self.session.get(self.url, verify=self.certificate_validation)

            if req.status_code == 200:
                response = req.text

                if destination and isinstance(destination, str):
                    FileHelper(destination).write(req.text, overwrite=True)

                return response

            raise PyFunceble.helpers.exceptions.UnableToDownload(
                f"{req.url} (retries: {self.retries} | status code: {req.status_code})"
            )
        except requests.exceptions.RequestException as exception:
            raise PyFunceble.helpers.exceptions.UnableToDownload(
                f"{self.url} (could not resolve?)"
            ) from exception

### `set_certificate_validation(value)`

Sets the value of the certificate validation.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`value` | `bool` | The value to set. | required

Source code in `PyFunceble/helpers/download.py`

    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208

    def set_certificate_validation(self, value: bool) -> "DownloadHelper":
        """
        Sets the value of the certificate validation.

        :param value:
            The value to set.
        """

        self.certificate_validation = value

        return self

### `set_own_proxy_handler(value)`

Sets the state of the own proxy handler.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`value` | `bool` | The value to set. | required

Source code in `PyFunceble/helpers/download.py`

    283
    284
    285
    286
    287
    288
    289
    290
    291
    292
    293

    def set_own_proxy_handler(self, value: bool) -> "DownloadHelper":
        """
        Sets the state of the own proxy handler.

        :param value:
            The value to set.
        """

        self.own_proxy_handler = value

        return self

### `set_proxies(value)`

Sets the proxy to use.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`value` | `Optional[dict]` | The proxy to use. When :code:`own_proxy_handler` is set to :code:`True`, the proxies are expected to come from the global configuration. Otherwise, the proxies are expected to be a dictionary as defined by the requests library. | required

Source code in `PyFunceble/helpers/download.py`

    329
    330
    331
    332
    333
    334
    335
    336
    337
    338
    339
    340
    341
    342
    343
    344

    def set_proxies(self, value: Optional[dict]) -> "DownloadHelper":
        """
        Sets the proxy to use.

        :param value:
            The proxy to use.

            When :code:`own_proxy_handler` is set to :code:`True`, the proxies
            are expected to come from the global configuration.
            Otherwise, the proxies are expected to be a dictionary as defined
            by the requests library.
        """

        self.proxies = value

        return self

### `set_retries(value)`

Sets the number of retries we are allowed to perform before raising an exception.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`value` | `int` | The number of retry to apply.i | required

Source code in `PyFunceble/helpers/download.py`

    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252

    def set_retries(self, value: int) -> "DownloadHelper":
        """
        Sets the number of retries we are allowed to perform before raising an
        exception.

        :param value:
            The number of retry to apply.i
        """

        self.retries = value

        return self

### `set_url(value)`

Sets the url to work with.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`value` | `str` | The URL to set. | required

Source code in `PyFunceble/helpers/download.py`

    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170

    def set_url(self, value: str) -> "DownloadHelper":
        """
        Sets the url to work with.

        :param value:
            The URL to set.
        """

        self.url = value

        return self